/***************************************************************************
 *   Copyright (C) 2007 by victor perez   *
 *   intirruphay@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CONFIGIMAGESIMP_H
#define CONFIGIMAGESIMP_H
class QDropEvent;
class QIconViewItem;
class QIconDragItem;

#include "configimages.h"
#include "imageitem.h"
class KPopupMenu;

class ImageManager;
class VcdManagerData;

class ConfigImagesImp : public ConfigImages
{
  Q_OBJECT

public:
    ConfigImagesImp(ImageManager* images, VcdManagerData* data,
     QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
  ~ConfigImagesImp();
  /*CoreManager* getCoreManager(){return a_manager;}*/
public slots:
  virtual void  iconView_dropped(QDropEvent*,const QValueList<QIconDragItem>&);
  /**
  * left click mount or unmount, right click view properties
  */
  virtual void  iconView_mouseButtonClicked(int,QIconViewItem*,const QPoint&);
  virtual void  slotRemove();
  virtual void  slotAdd();
  void slotShowProperties();
  void slotMountImage();
  void slotOpenImage();
  void slotModifyImage();
protected:
    void initialize();
    KPopupMenu* menuProperties();
    void addDragFile(QString file);
    QString nameIcon(ImageItem::Sts_Image sts );
private:
    ImageManager* a_im;
    VcdManagerData* a_data;
    ImageItem* a_current;
    QIconViewItem* a_curItemView;
};

#endif

