/***************************************************************************
 *   Copyright (C) 2007 by victor perez   *
 *   intirruphay@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef COREMANAGER_H
#define COREMANAGER_H


#include <dcopobject.h>
#include <qwidget.h>
#include <qpixmap.h>


#include <kconfig.h>


#include "imagemanager.h"
#include "vcdmanagerdata.h"

#include "resources.h"


class QPopupMenu;
class KPopupMenu;



/**
	@author victor perez <intirruphay@gmail.com>
*/
class CoreManager :public QWidget, public DCOPObject
{
    Q_OBJECT
    K_DCOP
k_dcop:
	bool mountImage(QString file);
	bool umountImage(QString file);
public:
    CoreManager(QWidget* parent= NULL);

    ~CoreManager();
   void adjustSize();
    void writeConfig();
    void readConfig();
    ImageManager* imageManager();
    KConfig* getConfiguration(){return a_config;}
    void setMensaje(QString m){a_mensaje=m;}
    QString mensaje(){return a_mensaje;}
    void showCustomTip(QString);
    VcdManagerData* getData(){return data;}
    bool isLoadedCdemu();
protected:
   void paintEvent(QPaintEvent *);
   void mousePressEvent(QMouseEvent *);
   KPopupMenu* handleRightClick();


public slots:
    void slotConfigurar();
    void slotPreferences();	
private:
   void showPopupMenu(QPopupMenu*);
private:
   QPixmap a_pixmap;
   ImageManager *a_images;
   KConfig *a_config;
    QString  a_mensaje;
    VcdManagerData *data;
};

#endif
