/***************************************************************************
 *   Copyright (C) 2007 by victor perez   *
 *   intirruphay@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef IMAGEITEM_H
#define IMAGEITEM_H

#include <qstring.h>

/**
	@author victor perez <victor@pig.com.pe>
*/
class ImageItem{
public:

typedef enum {
    //Montado en el sistema de archivos pero mediante el dispositivo loop
    IMG_MOUNTED = 1,
    //No montado solamente existe como entrada
    IMG_UMOUNTED = 0,
    //Cargado en el drive de cdemu pero no montado en el sistema de archivos
    IMG_CDEMU_LOADED=2,
    //Cargado en el drive cdemu y montado en el sistema de archivos
    IMG_CDEMU_MOUNTED=3
} Sts_Image;
    ImageItem();

    ~ImageItem();
    //Se refiere a que estar montado en el sistema de archivos
    bool isMounted();
    QString inline name(){return a_name;}
    QString inline pointMount(){return a_pointMount;}
    QString inline type(){return a_type;}
    QString inline id(){return a_id;}
    void changeStatus();
    void inline setName(QString name){a_name=name;}
    void inline setPointMount(QString point){a_pointMount=point;}
    void inline setType(QString type){a_type = type;}
    void setStatus(Sts_Image sts);
    void inline setId(QString id){a_id=id;}
    void inline setDevice(QString p){a_device=p;}
    QString inline device(){return a_device;}
    QString inline cdemuNumber(){return a_cdemuNum;}
    void inline setCdemuNumber(QString number){a_cdemuNum=number;}
    bool isUseCdemu();
    Sts_Image status();
    QString options(){return a_options;}
    void setOptions(QString op){a_options=op;}
private:
    /**Full pathname of image*/
    QString a_name;
    /**path of dir of point mount*/
    QString a_pointMount;
    /**Type of image*/
    QString a_type;
    /**Image id*/
    QString a_id;
    /**Status of image (no persistent)*/
    ImageItem::Sts_Image  a_sts;
    /**Device of use (no persistent)*/
    QString a_device;
    /**cdemu device number*/
    QString a_cdemuNum;
    /**aditional*/
    QString a_options;
};

#endif

