/***************************************************************************
 *   Copyright (C) 2007 by victor perez   *
 *   intirruphay@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <qinputdialog.h>
#include <qmessagebox.h>
#include <qlineedit.h>
#include <klocale.h>
#include "processcomunicator.h"

ProcessComunicator::ProcessComunicator(KProcess *proc)
 : QObject()
{
    a_proc = proc;
    a_result=false;
    connect(a_proc,SIGNAL(receivedStdout(KProcess*,char*,int)),
            this,SLOT(slotLeendoDatos(KProcess*,char*,int)));
    connect(a_proc,SIGNAL(receivedStderr(KProcess*,char*,int)),
            this,SLOT(slotLeendErr(KProcess*,char*,int )));
    connect(a_proc,SIGNAL(processExited(KProcess*)),
            this,SLOT(slotComandoEjecutado( KProcess*)));
}


ProcessComunicator::~ProcessComunicator()
{
    stoppingAll();
}

void ProcessComunicator::run()
{
    KShellProcess::Communication com = KShellProcess::All;
    a_proc->setUseShell(false);
    a_proc->start(KShellProcess::NotifyOnExit, com);
}

void ProcessComunicator::slotLeendoDatos(KProcess* pro,char* buff,int len)
{
    QMessageBox::information(0,i18n("Information"),i18n("Probando la salida"));
    QString salida = QString::fromLatin1(buff,len);
    bool ok;
    QString caption=i18n("Password");
    QString text = QInputDialog::getText((const QString &)caption,
                         (const QString &)salida,
                         QLineEdit::Password,QString::null,&ok);
    if(ok &&!text.isEmpty()){
        const char * buffer = text.latin1();
        int len =strlen(buffer);
        pro->writeStdin(buffer,len);
        pro->closeStdin();
    }
    //closeStdin();
}

void ProcessComunicator::slotLeendErr( KProcess* proc,char* buff,int len)
{
    //Mostrar el mensaje
    QString salida = QString::fromLatin1((const char*)buff,len);
    QMessageBox::information(0,i18n("Information"),salida);
    proc->closeAll();
    if(proc->isRunning())
        proc->kill();
}

void ProcessComunicator::slotComandoEjecutado( KProcess* proc)
{
    if(proc->normalExit()&&proc->exitStatus()==0){
        a_result=true;
    }else{
        a_result=false;
    }
}

bool ProcessComunicator::getResult()
{
    return a_result;
}

void ProcessComunicator::stoppingAll()
{

    if(a_proc->isRunning())
        a_proc->kill();
}
#include "processcomunicator.moc"
