/***************************************************************************
 *   Copyright (C) 2007 by victor perez   *
 *   intirruphay@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SELECTDIALOG_H
#define SELECTDIALOG_H

#include <qdialog.h>
#include <qcombobox.h>

#include "vcdmanagerdata.h"
#include "imageitem.h"

class QPushButton;
class QLineEdit;
class QFrame;
class QLabel;
class QHBoxLayout;
class QVBoxLayout;
class QGridLayout;

/**
	@author victor perez <victor@pig.com.pe>
*/
class SelectDialog : public QDialog
{
    Q_OBJECT
public:
    SelectDialog(VcdManagerData* co, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    SelectDialog(VcdManagerData* co, QString file, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    SelectDialog(VcdManagerData* co,ImageItem* it,
        QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );

    ~SelectDialog();
public slots:
    void addFileName();
    void addPointMount();
    //void accept();
    //void cancel();
    void languageChange();
protected slots:
    virtual void accept();
public:
    QString fileName();
    QString pointMount();
    QString type();
    QString prog();
    QString option();
protected:
    void initialize();
    int  getIndex(QComboBox* cb,QString cad);
private:
    QPushButton* a_btnFile;
    QPushButton* a_btnMount;
    QPushButton* a_btnCancel;
    QPushButton* a_btnAccept;
    QLineEdit*   a_edFileName;
    QLineEdit*   a_edPointMount;
    QHBoxLayout* a_hlayout1;
    QHBoxLayout* a_hlayout2;
    QHBoxLayout* a_hlayout3;
    QHBoxLayout* a_hlayout4;
    QVBoxLayout* a_vlayout;
    QGridLayout* a_glayout;
    QComboBox*   a_combo;
    QLabel*      a_lbcombo;
    QHBoxLayout* a_lacombo;
    QComboBox*   a_cbprog;
    QLabel*      a_lbprog;
    QHBoxLayout* a_laprog;
    VcdManagerData* a_data;
    QLineEdit*   a_edOption;
    QLabel*      a_lbOption;
};

#endif
