/***************************************************************************
 *   Copyright (C) 2007 by victor perez   *
 *   intirruphay@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <kconfig.h>

#include "vcdmanagerdata.h"
#include "resources.h"
#include "coremanager.h"

VcdManagerData::VcdManagerData(CoreManager* co)
{
    a_useCdemu=true;
    a_baseDirectory="/";
    a_core=co;
}


VcdManagerData::~VcdManagerData()
{
}

void VcdManagerData::readConfig( )
{
    KConfig *k=a_core->getConfiguration();
    k->setGroup(RC_GROUP_CONFIG);
    a_useCdemu =a_core->isLoadedCdemu()? k->readBoolEntry(RC_ENABLE_CDEMU):false;
    a_onlyLoad=a_useCdemu?k->readBoolEntry(RC_ONLY_LOAD_CDEMU):false;
    a_baseDirectory=k->readEntry(RC_BASE_DIRECTORY);
}

void VcdManagerData::writeConfig( )
{
    KConfig *k=a_core->getConfiguration();
    k->setGroup(RC_GROUP_CONFIG);
    k->writeEntry(RC_ENABLE_CDEMU,a_useCdemu);
    k->writeEntry(RC_BASE_DIRECTORY,a_baseDirectory);
    k->writeEntry(RC_ONLY_LOAD_CDEMU,a_onlyLoad);
    k->sync();
}


